Bug 1010512 - (mesos) Review Request: mesos - Cluster Manager
Review Request: mesos - Cluster Manager
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Will Benton
Fedora Extras Quality Assurance
:
Depends On: libprocess
Blocks: bigdata-review
  Show dependency treegraph
 
Reported: 2013-09-20 21:43 EDT by Timothy St. Clair
Modified: 2014-12-10 11:11 EST (History)
9 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-02-26 15:59:28 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
willb: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Timothy St. Clair 2013-09-20 21:43:20 EDT
Spec URL: http://tstclair.fedorapeople.org/mesos/mesos.spec
SRPM URL: http://tstclair.fedorapeople.org/mesos/mesos-0.15.0-0.2.01ccdb5.fc21.src.rpm

Description: Apache Mesos is a cluster manager that provides efficient resource
isolation and sharing across distributed applications, or frameworks.
It can run Hadoop, MPI, Hypertable, Spark, and other applications on
a dynamically shared pool of nodes.

Fedora Account System Username: tstclair
Comment 1 Timothy St. Clair 2013-09-25 15:13:05 EDT
Of note: currently there are java build products, but they are not part of the installation.  I'm currently working with upstream on fixing, but it will likely not be in this version.
Comment 2 Timothy St. Clair 2013-10-03 16:55:46 EDT
Updated SRPM: http://tstclair.fedorapeople.org/mesos/mesos-0.15.0-3.8037f97.fc21.src.rpm

remaining rpmlint items: 

mesos.x86_64: E: missing-call-to-setgroups /usr/lib64/libmesos-0.15.0.so.0.0.0

--> Opened a ticket upstream, I don't consider this a problem

mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-master-env
mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-slave-env
mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-deploy-env
mesos.x86_64: W: log-files-without-logrotate /var/log/mesos

--> non-issues

mesos.x86_64: W: no-manual-page-for-binary mesos-stop-slaves.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-log
mesos.x86_64: W: no-manual-page-for-binary mesos-start-slaves.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-start-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-daemon.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-slave
mesos.x86_64: W: no-manual-page-for-binary mesos-master
mesos.x86_64: W: no-manual-page-for-binary mesos-start-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-mesos
mesos.x86_64: W: no-manual-page-for-binary mesos-local

--> will open up tickets upstream around documentation
1 packages and 0 specfiles checked; 1 errors, 16 warnings.
Comment 3 Timothy St. Clair 2013-10-18 15:48:06 EDT
updated srpm: http://tstclair.fedorapeople.org/mesos/mesos-0.15.0-4.464661f.fc21.src.rpm
updated spec: http://tstclair.fedorapeople.org/mesos/mesos.spec

Notes: Per discussions with upstream, subpackages have been created for sub-elements which are now subsumed within the mesos package.  

I've tried to run through as much of the review process as possible to ease the review, but items should still be double checked.  
--------------------------------------------------------
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[?]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated", "*No copyright* Apache (v2.0)". 209 files have
     unknown license. Detailed output of licensecheck in
     /home/tstclair/work/spaces/mesos/mesos-rpm/review-mesos/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/include/mesos
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/systemd/system,
     /usr/lib/systemd, /usr/include/mesos, /etc/tmpfiles.d
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[?]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[?]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[-]: Package is not known to require an ExcludeArch tag.

-- Temporarily disable arm, but will manage and converse with upstream

[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 163840 bytes in 8 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.

-- This is an issue and I'm tracking, but not a blocker

[?]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[?]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in mesos-
     stout-devel , mesos-libprocess , mesos-libprocess-devel
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[?]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.

-- There are issues within the tests, and tickets have been opened upstream and I'm tracking

[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[-]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
     Note: Arch-ed rpms have a total of 1996800 bytes in /usr/share
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: mesos-0.15.0-4.464661f.fc21.x86_64.rpm
          mesos-stout-devel-0.15.0-4.464661f.fc21.noarch.rpm
          mesos-libprocess-0.15.0-4.464661f.fc21.x86_64.rpm
          mesos-libprocess-devel-0.15.0-4.464661f.fc21.x86_64.rpm
          mesos-devel-0.15.0-4.464661f.fc21.x86_64.rpm
          mesos-0.15.0-4.464661f.fc21.src.rpm
mesos.x86_64: E: missing-call-to-setgroups /usr/lib64/libmesos-0.15.0.so.0.0.0

-- I looked into the code and opened a ticket, but I do not consider this a blocker.

mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-master-env
mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-slave-env
mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-deploy-env

-- False positive, imo

mesos.x86_64: W: log-files-without-logrotate /var/log/mesos

-- I'm not certain about *this one, but I don't consider it a blocker.

mesos.x86_64: W: no-manual-page-for-binary mesos-stop-slaves.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-log
mesos.x86_64: W: no-manual-page-for-binary mesos-start-slaves.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-start-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-daemon.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-slave
mesos.x86_64: W: no-manual-page-for-binary mesos-master
mesos.x86_64: W: no-manual-page-for-binary mesos-start-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-mesos
mesos.x86_64: W: no-manual-page-for-binary mesos-local

-- I've opened tickets upstream around this

mesos-libprocess.x86_64: W: one-line-command-in-%post /sbin/ldconfig
mesos-devel.x86_64: W: no-documentation
6 packages and 0 specfiles checked; 1 errors, 18 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint mesos-libprocess mesos-libprocess-devel mesos-stout-devel mesos-devel mesos
mesos-libprocess.x86_64: W: one-line-command-in-%post /sbin/ldconfig
mesos-devel.x86_64: W: no-documentation
mesos.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libmesos-0.15.0.so.0.0.0 /lib64/libhttp_parser.so.2
mesos.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libmesos-0.15.0.so.0.0.0 /lib64/libev.so.4
mesos.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libmesos-0.15.0.so.0.0.0 /lib64/libz.so.1

-- I'm still looking into this, it looks like the linking of libprocess chains in it's deps 
-- even though there is no explicit statement in the Makefile.am, I'm tracking to clean but I would 
-- not construe this as a blocker

mesos.x86_64: E: missing-call-to-setgroups /usr/lib64/libmesos-0.15.0.so.0.0.0
mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-master-env
mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-slave-env
mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-deploy-env
mesos.x86_64: W: log-files-without-logrotate /var/log/mesos
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-slaves.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-log
mesos.x86_64: W: no-manual-page-for-binary mesos-start-slaves.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-start-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-daemon.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-slave
mesos.x86_64: W: no-manual-page-for-binary mesos-master
mesos.x86_64: W: no-manual-page-for-binary mesos-start-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-mesos
mesos.x86_64: W: no-manual-page-for-binary mesos-local

-- Same as above.

5 packages and 0 specfiles checked; 1 errors, 21 warnings.
# echo 'rpmlint-done:'



Requires
--------
mesos-libprocess (rpmlib, GLIBC filtered):
    /bin/sh
    libc.so.6()(64bit)
    libev.so.4()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_4.0.0)(64bit)
    libglog.so.0()(64bit)
    libhttp_parser.so.2()(64bit)
    libm.so.6()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libz.so.1()(64bit)
    rtld(GNU_HASH)

mesos-libprocess-devel (rpmlib, GLIBC filtered):
    libprocess.so.0()(64bit)
    mesos-libprocess
    mesos-stout-devel

mesos-stout-devel (rpmlib, GLIBC filtered):
    boost-devel
    glog-devel
    gmock-devel
    gtest-devel
    libcurl-devel
    protobuf-devel
    zlib-devel

mesos-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libmesos-0.15.0.so.0()(64bit)
    mesos(x86-64)
    mesos-libprocess-devel

mesos (rpmlib, GLIBC filtered):
    /bin/sh
    config(mesos)
    libc.so.6()(64bit)
    libcurl.so.4()(64bit)
    libev.so.4()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_4.0.0)(64bit)
    libglog.so.0()(64bit)
    libhttp_parser.so.2()(64bit)
    libjvm.so()(64bit)
    libjvm.so(SUNWprivate_1.1)(64bit)
    libleveldb.so.1()(64bit)
    libm.so.6()(64bit)
    libmesos-0.15.0.so.0()(64bit)
    libprocess.so.0()(64bit)
    libprotobuf.so.8()(64bit)
    libpthread.so.0()(64bit)
    librt.so.1()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libz.so.1()(64bit)
    libzookeeper_mt.so.2()(64bit)
    mesos-libprocess
    protobuf-python
    rtld(GNU_HASH)



Provides
--------
mesos-libprocess:
    libprocess.so.0()(64bit)
    mesos-libprocess
    mesos-libprocess(x86-64)

mesos-libprocess-devel:
    mesos-libprocess-devel
    mesos-libprocess-devel(x86-64)

mesos-stout-devel:
    mesos-stout-devel

mesos-devel:
    mesos-devel
    mesos-devel(x86-64)
    pkgconfig(mesos)

mesos:
    config(mesos)
    libmesos-0.15.0.so.0()(64bit)
    mesos
    mesos(x86-64)
Comment 4 Björn "besser82" Esser 2013-10-21 10:13:43 EDT
taken  ;)
Comment 5 Timothy St. Clair 2013-11-11 13:55:09 EST
Any update?
Comment 6 Timothy St. Clair 2013-11-21 15:33:04 EST
updated spec: http://tstclair.fedorapeople.org/mesos/mesos.spec
updated srpm: http://tstclair.fedorapeople.org/mesos/mesos-0.16.0-1.d3557e8.fc21.src.rpm

Notes: 
mesos.x86_64: E: missing-call-to-setgroups /usr/lib64/libmesos-0.16.0.so.0.0.0

^ False positive imo.

mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-master-env
mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-deploy-env
mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-slave-env
mesos.x86_64: W: log-files-without-logrotate /var/log/mesos

^ expected

mesos.x86_64: W: no-manual-page-for-binary mesos-stop-slaves.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-log
mesos.x86_64: W: no-manual-page-for-binary mesos
mesos.x86_64: W: no-manual-page-for-binary mesos-local
mesos.x86_64: W: no-manual-page-for-binary mesos-start-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-daemon.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-slave
mesos.x86_64: W: no-manual-page-for-binary mesos-ps
mesos.x86_64: W: no-manual-page-for-binary mesos-tail
mesos.x86_64: W: no-manual-page-for-binary mesos-master
mesos.x86_64: W: no-manual-page-for-binary mesos-start-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-resolve
mesos.x86_64: W: no-manual-page-for-binary mesos-execute
mesos.x86_64: W: no-manual-page-for-binary mesos-cat
mesos.x86_64: W: no-manual-page-for-binary mesos-start-slaves.sh

^ non-blocking
Comment 7 Will Benton 2013-12-19 15:45:27 EST
Some issues here, but the most serious one is bundling.  (It basically doesn't matter that upstream is bundling.)

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package contains BR: python2-devel or python3-devel

You should replace the unversioned python-devel BR with python2-devel or python3-devel as appropriate.

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[!]: Package requires other packages for directories it uses.
     mesos-devel should own %{includedir}/mesos.  Currently stout and libprocess are in there as well, but these probably shouldn't be.
	  
[!]: Package must own all directories that it creates.
     as above

[x]: %build honors applicable compiler flags or justifies otherwise.
     But see below re: smp_mflags
	  
[!]: Package contains no bundled libraries without FPC exception.
     leveldb, stout, and libprocess are all available from separate upstreams (stout and leveldb are already in Fedora).  If you can justify exceptions (seems likely for stout and possible for libprocess?), then apply for them; otherwise, mesos will need to be patched to use system copies.  Other bundled libraries in 3rdparty should be removed before building.

[x]: Changelog in prescribed format.
[!]: Sources contain only permissible code or content.
     as above re: bundled libs

[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[!]: Package is not known to require an ExcludeArch tag.
     Please comment the ExcludeArch with justification.

[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.
     not a blocker, but please justify in a spec comment why it isn't there.
	  
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     (NB: this is another reason why stout and libprocess shouldn't be bundled)

[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
     Tests skipped due to problems in mock; not a blocker

[x]: Packages should try to preserve timestamps of original installed files.
[!]: Spec use %global instead of %define unless justified.
     Please use %global throughout.

[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.

===== EXTRA items =====

Generic:
[-]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
     Note: Arch-ed rpms have a total of 1587200 bytes in /usr/share
[x]: Rpmlint is run on all installed packages.
     NB:  Logrotate configuration is really important for a long-running service.

[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: mesos-0.16.0-1.d3557e8.fc20.x86_64.rpm
          mesos-stout-devel-0.16.0-1.d3557e8.fc20.noarch.rpm
          mesos-libprocess-0.16.0-1.d3557e8.fc20.x86_64.rpm
          mesos-libprocess-devel-0.16.0-1.d3557e8.fc20.x86_64.rpm
          mesos-devel-0.16.0-1.d3557e8.fc20.x86_64.rpm
          mesos-0.16.0-1.d3557e8.fc20.src.rpm
mesos.x86_64: E: missing-call-to-setgroups /usr/lib64/libmesos-0.16.0.so.0.0.0
mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-master-env
mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-deploy-env
mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-slave-env
mesos.x86_64: W: log-files-without-logrotate /var/log/mesos
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-slaves.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-log
mesos.x86_64: W: no-manual-page-for-binary mesos
mesos.x86_64: W: no-manual-page-for-binary mesos-local
mesos.x86_64: W: no-manual-page-for-binary mesos-start-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-daemon.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-slave
mesos.x86_64: W: no-manual-page-for-binary mesos-ps
mesos.x86_64: W: no-manual-page-for-binary mesos-tail
mesos.x86_64: W: no-manual-page-for-binary mesos-master
mesos.x86_64: W: no-manual-page-for-binary mesos-start-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-resolve
mesos.x86_64: W: no-manual-page-for-binary mesos-execute
mesos.x86_64: W: no-manual-page-for-binary mesos-cat
mesos.x86_64: W: no-manual-page-for-binary mesos-start-slaves.sh
mesos-libprocess.x86_64: W: one-line-command-in-%post /sbin/ldconfig
mesos-devel.x86_64: W: no-documentation
6 packages and 0 specfiles checked; 1 errors, 23 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint mesos-libprocess mesos-libprocess-devel mesos-stout-devel mesos-devel mesos
mesos-libprocess.x86_64: W: one-line-command-in-%post /sbin/ldconfig
mesos-devel.x86_64: W: no-documentation
mesos.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libmesos-0.16.0.so.0.0.0 /lib64/libhttp_parser.so.2
mesos.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libmesos-0.16.0.so.0.0.0 /lib64/libev.so.4
mesos.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libmesos-0.16.0.so.0.0.0 /lib64/libz.so.1
mesos.x86_64: E: missing-call-to-setgroups /usr/lib64/libmesos-0.16.0.so.0.0.0
mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-master-env
mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-deploy-env
mesos.x86_64: W: non-conffile-in-etc /etc/sysconfig/mesos/mesos-slave-env
mesos.x86_64: W: log-files-without-logrotate /var/log/mesos
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-slaves.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-log
mesos.x86_64: W: no-manual-page-for-binary mesos
mesos.x86_64: W: no-manual-page-for-binary mesos-local
mesos.x86_64: W: no-manual-page-for-binary mesos-start-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-daemon.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-slave
mesos.x86_64: W: no-manual-page-for-binary mesos-ps
mesos.x86_64: W: no-manual-page-for-binary mesos-tail
mesos.x86_64: W: no-manual-page-for-binary mesos-master
mesos.x86_64: W: no-manual-page-for-binary mesos-start-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-resolve
mesos.x86_64: W: no-manual-page-for-binary mesos-execute
mesos.x86_64: W: no-manual-page-for-binary mesos-cat
mesos.x86_64: W: no-manual-page-for-binary mesos-start-slaves.sh
5 packages and 0 specfiles checked; 1 errors, 26 warnings.
# echo 'rpmlint-done:'



Requires
--------
mesos-libprocess (rpmlib, GLIBC filtered):
    /bin/sh
    libc.so.6()(64bit)
    libev.so.4()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_4.0.0)(64bit)
    libglog.so.0()(64bit)
    libhttp_parser.so.2()(64bit)
    libm.so.6()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libz.so.1()(64bit)
    rtld(GNU_HASH)

mesos-libprocess-devel (rpmlib, GLIBC filtered):
    libprocess.so.0()(64bit)
    mesos-libprocess
    mesos-stout-devel

mesos-stout-devel (rpmlib, GLIBC filtered):
    boost-devel
    glog-devel
    gmock-devel
    gtest-devel
    libcurl-devel
    protobuf-devel
    zlib-devel

mesos-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libmesos-0.16.0.so.0()(64bit)
    mesos(x86-64)
    mesos-libprocess-devel

mesos (rpmlib, GLIBC filtered):
    /bin/sh
    /usr/bin/env
    config(mesos)
    libc.so.6()(64bit)
    libcurl.so.4()(64bit)
    libev.so.4()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_4.0.0)(64bit)
    libglog.so.0()(64bit)
    libhttp_parser.so.2()(64bit)
    libjvm.so()(64bit)
    libjvm.so(SUNWprivate_1.1)(64bit)
    libleveldb.so.1()(64bit)
    libm.so.6()(64bit)
    libmesos-0.16.0.so.0()(64bit)
    libprocess.so.0()(64bit)
    libprotobuf.so.8()(64bit)
    libpthread.so.0()(64bit)
    librt.so.1()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libz.so.1()(64bit)
    libzookeeper_mt.so.2()(64bit)
    mesos-libprocess
    protobuf-python
    rtld(GNU_HASH)



Provides
--------
mesos-libprocess:
    libprocess.so.0()(64bit)
    mesos-libprocess
    mesos-libprocess(x86-64)

mesos-libprocess-devel:
    mesos-libprocess-devel
    mesos-libprocess-devel(x86-64)

mesos-stout-devel:
    mesos-stout-devel

mesos-devel:
    mesos-devel
    mesos-devel(x86-64)
    pkgconfig(mesos)

mesos:
    config(mesos)
    libmesos-0.16.0.so.0()(64bit)
    mesos
    mesos(x86-64)



Source checksums
----------------
https://github.com/timothysc/mesos/archive/d3557e8fcd9b96a11fbdd9d28c86bd2b4965c190/mesos-0.16.0-d3557e8.tar.gz :
  CHECKSUM(SHA256) this package     : 975e5d18345258a6d06ff6cfed4514899f77753043d4757588d6ff5c9c2f2518
  CHECKSUM(SHA256) upstream package : 975e5d18345258a6d06ff6cfed4514899f77753043d4757588d6ff5c9c2f2518


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -b 1010512 -m fedora-20-x86_64
Buildroot used: fedora-20-x86_64
Active plugins: Generic, Python, Shell-api, C/C++
Disabled plugins: Java, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 8 Will Benton 2013-12-19 16:35:54 EST
We also need to work from a pristine source and a patchset.  Since the delta between upstream and Tim's fork is very large (primarily due to removing binaries), the package should probably remove binaries in %prep instead of as a patch.
Comment 9 Timothy St. Clair 2013-12-19 16:47:10 EST
[!]: Package requires other packages for directories it uses.
     mesos-devel should own %{includedir}/mesos.  Currently stout and libprocess are in there as well, but these probably shouldn't be.
	  
[!]: Package must own all directories that it creates.
     as above

	  
>[!]: Package contains no bundled libraries without FPC exception.
>     leveldb, stout, and libprocess are all available from separate upstreams 
> (stout and leveldb are already in Fedora).  If you can justify exceptions 
> (seems likely for stout and possible for libprocess?), then apply for them; 
> otherwise, mesos will need to be patched to use system copies.  Other bundled 
> libraries in 3rdparty should be removed before building.

Both stout and libprocess breakout <> subsuming were a result of numerous conversations with upstream.  Originally BenH had intended for them to exist as separate entities, but they were so tightly coupled with the root project that the canonical source is the mesos project.  The "resolution" that made the most sense was instead to kill off the separate packages before they hit a distribution, as they are not versioned independently of mesos.  However, a compromise was to create sub-packages to allow folks to use the libraries.  I supposed I could leave the sub-package breakout in the .spec and just have a mesos-devel.  From everyone's perspective is much more simple, should the desire exist to breakout sub-packages for other reasons, the plumbing will exist.  

leveldb should not exist, it was likely a result from a merged update. 


>[!]: Sources contain only permissible code or content.
>     as above re: bundled libs

>[!]: Package is not known to require an ExcludeArch tag.
>     Please comment the ExcludeArch with justification.

Sources contain code which currently do not compile on arm, and upstream has no explicit intent to support + not all dependencies exist iirc. 

>[!]: Uses parallel make %{?_smp_mflags} macro.
>     not a blocker, but please justify in a spec comment why it isn't there.

Currently not capable with upstream
	  
>[!]: %check is present and all tests pass.
>     Tests skipped due to problems in mock; not a blocker

Tests fail in mock, but succeed outside, some are intermittent. 

>[!]: Spec use %global instead of %define unless justified.
>     Please use %global throughout.
Comment 10 Timothy St. Clair 2014-01-06 13:20:18 EST
Updated, I believe I've addressed all the items listed above.  I've removed the sub-packaging too, as it doesn't exist anywhere else.  I will need to remove any other sub-packages that exist. 

srpm: http://tstclair.fedorapeople.org/mesos/mesos-0.16.0-2.d0cb03f.fc21.src.rpm
spec: http://tstclair.fedorapeople.org/mesos/mesos.spec
Comment 11 Timothy St. Clair 2014-01-06 13:23:30 EST
> I will need to remove any other sub-packages that exist. 

from fedora respos
Comment 12 Timothy St. Clair 2014-01-06 16:22:57 EST
Update includes a generate-tarball.sh mod with switched to dual purpose the spec file, in the vain that some day we can just pull directly from github.  

ref:https://fedoraproject.org/wiki/Packaging:SourceURL#When_Upstream_uses_Prohibited_Code
Comment 13 Timothy St. Clair 2014-01-09 14:02:25 EST
stout is now retired as a separate package.
Comment 14 Will Benton 2014-01-09 17:30:47 EST
The generated tarball policy doesn't apply in this case if there is nothing in the upstream tarball that we're legally encumbered from uploading to SCM.  Please move the bundled library deletion to your %prep scriptlet and work from a pristine source.  I'll update the rest of the review in a separate comment.
Comment 15 Timothy St. Clair 2014-01-09 21:28:26 EST
updated, with same urls.  

You will notice I conditionalized the .spec file around that.
Comment 16 Will Benton 2014-01-09 22:15:46 EST
(In reply to Timothy St. Clair from comment #15)
> updated, with same urls.  
> 
> You will notice I conditionalized the .spec file around that.

I did!  Thanks for changing the default behavior; you can remove those conditionals and related comments when you make these last few changes.  Here's the rest of my updated review (reflecting the spec as of earlier today with the generated tarball):

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


Issues:
=======

- mesos must BuildRequire: python2-devel.  See http://fedoraproject.org/wiki/Packaging:Python#BuildRequires
- The spec must work from a pristine upstream tarball unless there are legal reasons why we cannot.  Please move all bundled library removal in the %prep scriptlet and use an upstream tarball.
- Integration.patch is 1.8 mb and primarily consists of file moves, which makes it tedious to inspect.  Please move files in %prep rather than in a patch!  In addition, consider splitting up Fedora integration changes into several smaller patches that each reflect a high-level change.
- mesos should not own %{_unitdir}.
- The python interface should go in %{python_sitearch}.  As it stands, it looks like it's getting built but not installed.  (It looks like the makefile needs to call out to setup.py.)
- I think %{python_sitelib} is a more appropriate place for the (internal?) modules that get installed in libexecdir:  https://fedoraproject.org/wiki/Packaging:Guidelines#Libexecdir  If these are part of the mesos module (from the client library), I think they'll need to go in sitearch since the rest of the mesos module is arch-specific.

- I'll buy that the rpmlint error is possibly spurious, and I see that you've opened a JIRA upstream about it.
- Consider splitting the web UI out into a noarch subpackage.  Also, you should track the "handwavy future" of the Web Assets work, since that will impact this package sooner or later:  http://fedoraproject.org/wiki/Changes/Web_Assets#Handwavy_Future

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Apache (v2.0)", "BSD (3 clause)", "Unknown or generated". 223 files have
     unknown license. Detailed output of licensecheck in
     /home/wibenton/devel/review/1010512-mesos/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/systemd, /etc/tmpfiles.d
[!]: Package does not own files or directories owned by other packages.
     Note: Dirs in package are owned also by: /usr/lib/systemd/system(systemd)
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 81920 bytes in 4 files.
[ ]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[!]: A package which is used by another package via an egg interface should
     provide egg info.
[!]: Package meets the Packaging Guidelines::Python

- supply proper BuildRequires for the major versions of python you wish to support
- If we for intend users to use the Mesos python interface, it needs to be packaged appropriately; see above under "issues" for detail.

[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.

- fine, this doesn't work upstream

[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: SourceX tarball generation or download is documented.

- but please use upstream tarball instead, as above

[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: The placement of pkgconfig(.pc) files are correct.
[!]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.

- see above under "issues"

[x]: Rpmlint is run on all installed packages.
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: mesos-0.16.0-2.d0cb03f.fc21.x86_64.rpm
          mesos-devel-0.16.0-2.d0cb03f.fc21.x86_64.rpm
          mesos-0.16.0-2.d0cb03f.fc21.src.rpm
mesos.x86_64: E: missing-call-to-setgroups /usr/lib64/libmesos-0.16.0.so.0.0.0
mesos.x86_64: W: non-conffile-in-etc /etc/mesos/mesos-deploy-env.sh.template
mesos.x86_64: W: non-conffile-in-etc /etc/mesos/mesos-slave-env.sh.template
mesos.x86_64: W: non-conffile-in-etc /etc/mesos/mesos-master-env.sh.template
mesos.x86_64: W: log-files-without-logrotate /var/log/mesos
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-slaves.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-log
mesos.x86_64: W: no-manual-page-for-binary mesos
mesos.x86_64: W: no-manual-page-for-binary mesos-local
mesos.x86_64: W: no-manual-page-for-binary mesos-start-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-daemon.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-slave
mesos.x86_64: W: no-manual-page-for-binary mesos-ps
mesos.x86_64: W: no-manual-page-for-binary mesos-tail
mesos.x86_64: W: no-manual-page-for-binary mesos-master
mesos.x86_64: W: no-manual-page-for-binary mesos-start-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-resolve
mesos.x86_64: W: no-manual-page-for-binary mesos-execute
mesos.x86_64: W: no-manual-page-for-binary mesos-cat
mesos.x86_64: W: no-manual-page-for-binary mesos-start-slaves.sh
mesos.src: W: strange-permission generate-tarball.sh 0775L
mesos.src: W: invalid-url Source0: mesos-0.16.0-rc1-clean.tar.gz
3 packages and 0 specfiles checked; 1 errors, 23 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint mesos-devel mesos
mesos.x86_64: E: missing-call-to-setgroups /usr/lib64/libmesos-0.16.0.so.0.0.0
mesos.x86_64: W: non-conffile-in-etc /etc/mesos/mesos-deploy-env.sh.template
mesos.x86_64: W: non-conffile-in-etc /etc/mesos/mesos-slave-env.sh.template
mesos.x86_64: W: non-conffile-in-etc /etc/mesos/mesos-master-env.sh.template
mesos.x86_64: W: log-files-without-logrotate /var/log/mesos
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-slaves.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-log
mesos.x86_64: W: no-manual-page-for-binary mesos
mesos.x86_64: W: no-manual-page-for-binary mesos-local
mesos.x86_64: W: no-manual-page-for-binary mesos-start-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-daemon.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-slave
mesos.x86_64: W: no-manual-page-for-binary mesos-ps
mesos.x86_64: W: no-manual-page-for-binary mesos-tail
mesos.x86_64: W: no-manual-page-for-binary mesos-master
mesos.x86_64: W: no-manual-page-for-binary mesos-start-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-resolve
mesos.x86_64: W: no-manual-page-for-binary mesos-execute
mesos.x86_64: W: no-manual-page-for-binary mesos-cat
mesos.x86_64: W: no-manual-page-for-binary mesos-start-slaves.sh
2 packages and 0 specfiles checked; 1 errors, 21 warnings.
# echo 'rpmlint-done:'



Requires
--------
mesos-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libmesos-0.16.0.so.0()(64bit)
    mesos(x86-64)

mesos (rpmlib, GLIBC filtered):
    /bin/sh
    /usr/bin/env
    config(mesos)
    libc.so.6()(64bit)
    libcurl.so.4()(64bit)
    libev.so.4()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_4.0.0)(64bit)
    libglog.so.0()(64bit)
    libhttp_parser.so.2()(64bit)
    libjvm.so()(64bit)
    libjvm.so(SUNWprivate_1.1)(64bit)
    libleveldb.so.1()(64bit)
    libm.so.6()(64bit)
    libmesos-0.16.0.so.0()(64bit)
    libprotobuf.so.8()(64bit)
    libpthread.so.0()(64bit)
    librt.so.1()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libzookeeper_mt.so.2()(64bit)
    protobuf-python
    rtld(GNU_HASH)



Provides
--------
mesos-devel:
    mesos-devel
    mesos-devel(x86-64)
    pkgconfig(mesos)

mesos:
    config(mesos)
    libmesos-0.16.0.so.0()(64bit)
    mesos
    mesos(x86-64)



Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -b 1010512 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Python, Shell-api, C/C++
Disabled plugins: Java, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 17 Timothy St. Clair 2014-01-13 15:49:23 EST
Updated, same URLs.  Notes are inlined below.

> - mesos must BuildRequire: python2-devel.  See 
> http://fedoraproject.org/wiki/Packaging:Python#BuildRequires

- done

> - The spec must work from a pristine upstream tarball unless there are legal 
> reasons why we cannot.  Please move all bundled library removal in the %prep 
> scriptlet and use an upstream tarball.

- done

>- Integration.patch is 1.8 mb and primarily consists of file moves, which makes 
> it tedious to inspect.  Please move files in %prep rather than in a patch!  In 
>addition, consider splitting up Fedora integration changes into several smaller 
>patches that each reflect a high-level change.

#####################################
# NOTE: The modifications have been broken into three patches which are
# consistent with *many* other projects, and are tracking @
#
# https://github.com/timothysc/mesos
# Full integration stream is: https://github.com/timothysc/mesos/tree/0.16.0-integ
#
# The shuffle patch is maintained because it is a
# patch that is trying to be pushed upstream, thus breaking it out as a series
# of steps doesn't make sense, but has been isolated into it's own patch per review.
####################################

> - mesos should not own %{_unitdir}.

- done 

> - The python interface should go in %{python_sitearch}.  As it stands, it 
> looks like it's getting built but not installed.  (It looks like the makefile > needs to call out to setup.py.)

Currently upstream builds a client library, and that the cli tools do not depend  on.  There are open upstream JIRA's around language bindings, and I'm tracking.  However, I don't want to prematurely put them into the wild until they have vetted. https://issues.apache.org/jira/browse/MESOS-899

This also holds for the java interface which also has the same issue atm.  

> - I think %{python_sitelib} is a more appropriate place for the (internal?) 
> modules that get installed in libexecdir:  
> https://fedoraproject.org/wiki/Packaging:Guidelines#Libexecdir  If these are 
> part of the mesos module (from the client library), I think they'll need to go 
> in sitearch since the rest of the mesos module is arch-specific.

- done
Comment 18 Will Benton 2014-01-17 17:06:42 EST
Thanks for making these changes, Tim.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 81920 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.

- ok since upstream build isn't compatible

[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
     Note: Arch-ed rpms have a total of 1546240 bytes in /usr/share

- comment from earlier review still holds (but still not a blocker)

[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: mesos-0.16.0-2.d0cb03f.fc21.x86_64.rpm
          mesos-devel-0.16.0-2.d0cb03f.fc21.x86_64.rpm
          mesos-0.16.0-2.d0cb03f.fc21.src.rpm
mesos.x86_64: E: missing-call-to-setgroups /usr/lib64/libmesos-0.16.0.so.0.0.0
mesos.x86_64: W: non-conffile-in-etc /etc/mesos/mesos-deploy-env.sh.template
mesos.x86_64: W: non-conffile-in-etc /etc/mesos/mesos-slave-env.sh.template
mesos.x86_64: W: non-conffile-in-etc /etc/mesos/mesos-master-env.sh.template
mesos.x86_64: W: log-files-without-logrotate /var/log/mesos
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-slaves.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-log
mesos.x86_64: W: no-manual-page-for-binary mesos
mesos.x86_64: W: no-manual-page-for-binary mesos-local
mesos.x86_64: W: no-manual-page-for-binary mesos-start-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-daemon.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-slave
mesos.x86_64: W: no-manual-page-for-binary mesos-ps
mesos.x86_64: W: no-manual-page-for-binary mesos-tail
mesos.x86_64: W: no-manual-page-for-binary mesos-master
mesos.x86_64: W: no-manual-page-for-binary mesos-start-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-resolve
mesos.x86_64: W: no-manual-page-for-binary mesos-execute
mesos.x86_64: W: no-manual-page-for-binary mesos-cat
mesos.x86_64: W: no-manual-page-for-binary mesos-start-slaves.sh
3 packages and 0 specfiles checked; 1 errors, 21 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint mesos-devel mesos
mesos.x86_64: E: missing-call-to-setgroups /usr/lib64/libmesos-0.16.0.so.0.0.0
mesos.x86_64: W: non-conffile-in-etc /etc/mesos/mesos-deploy-env.sh.template
mesos.x86_64: W: non-conffile-in-etc /etc/mesos/mesos-slave-env.sh.template
mesos.x86_64: W: non-conffile-in-etc /etc/mesos/mesos-master-env.sh.template
mesos.x86_64: W: log-files-without-logrotate /var/log/mesos
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-slaves.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-log
mesos.x86_64: W: no-manual-page-for-binary mesos
mesos.x86_64: W: no-manual-page-for-binary mesos-local
mesos.x86_64: W: no-manual-page-for-binary mesos-start-cluster.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-daemon.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-slave
mesos.x86_64: W: no-manual-page-for-binary mesos-ps
mesos.x86_64: W: no-manual-page-for-binary mesos-tail
mesos.x86_64: W: no-manual-page-for-binary mesos-master
mesos.x86_64: W: no-manual-page-for-binary mesos-start-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-stop-masters.sh
mesos.x86_64: W: no-manual-page-for-binary mesos-resolve
mesos.x86_64: W: no-manual-page-for-binary mesos-execute
mesos.x86_64: W: no-manual-page-for-binary mesos-cat
mesos.x86_64: W: no-manual-page-for-binary mesos-start-slaves.sh
2 packages and 0 specfiles checked; 1 errors, 21 warnings.
# echo 'rpmlint-done:'



Requires
--------
mesos-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libmesos-0.16.0.so.0()(64bit)
    mesos(x86-64)

mesos (rpmlib, GLIBC filtered):
    /bin/sh
    /usr/bin/env
    config(mesos)
    libc.so.6()(64bit)
    libcurl.so.4()(64bit)
    libev.so.4()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgcc_s.so.1(GCC_4.0.0)(64bit)
    libglog.so.0()(64bit)
    libhttp_parser.so.2()(64bit)
    libjvm.so()(64bit)
    libjvm.so(SUNWprivate_1.1)(64bit)
    libleveldb.so.1()(64bit)
    libm.so.6()(64bit)
    libmesos-0.16.0.so.0()(64bit)
    libprotobuf.so.8()(64bit)
    libpthread.so.0()(64bit)
    librt.so.1()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libzookeeper_mt.so.2()(64bit)
    protobuf-python
    python(abi)
    rtld(GNU_HASH)



Provides
--------
mesos-devel:
    mesos-devel
    mesos-devel(x86-64)
    pkgconfig(mesos)

mesos:
    config(mesos)
    libmesos-0.16.0.so.0()(64bit)
    mesos
    mesos(x86-64)



Source checksums
----------------
https://github.com/apache/mesos/archive/d0cb03f9535ae1b6997f60f4de50ca96f6b19e70/mesos-0.16.0-d0cb03f.tar.gz :
  CHECKSUM(SHA256) this package     : a912104a359b76631b2e67dd5e2a6e83c473351b92f67f597f8f6ba7b3ba613e
  CHECKSUM(SHA256) upstream package : a912104a359b76631b2e67dd5e2a6e83c473351b92f67f597f8f6ba7b3ba613e


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -b 1010512 -m fedora-rawhide-x86_64
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Python, Shell-api, C/C++
Disabled plugins: Java, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 19 Timothy St. Clair 2014-01-17 17:32:20 EST
New Package SCM Request
=======================
Package Name: mesos
Short Description: Cluster manager for sharing distributed application frameworks
Owners: tstclair
Branches: f20
InitialCC: bigdata-sig
Comment 20 Gwyn Ciesla 2014-01-21 09:02:22 EST
bigdata-sig is not a valid FAS account.
Comment 21 Timothy St. Clair 2014-01-21 09:53:19 EST
New Package SCM Request
=======================
Package Name: mesos
Short Description: Cluster manager for sharing distributed application frameworks
Owners: tstclair
Branches: f20
Comment 22 Dennis Gilmore 2014-01-21 11:02:17 EST
Git done (by process-git-requests).
Comment 23 Ratnadeep Debnath 2014-12-08 16:03:44 EST
Package Change Request
======================
Package Name: mesos
New Branches: epel7

SPEC Url: https://rtnpro.fedorapeople.org/Packages/SPECS/mesos.spec
SRPM Url: https://rtnpro.fedorapeople.org/Packages/SRPMS/mesos-0.21.0-5.ab8fa65.el7.centos.src.rpm
Comment 24 Timothy St. Clair 2014-12-08 16:20:16 EST
Ratnadeep you would need to drag in the missing transitive dependencies into epel in order to make that happen.
Comment 25 Ratnadeep Debnath 2014-12-09 12:08:44 EST
Hey Timothy,

Could you please elaborate on what do you mean by "drag in the missing transitive dependencies"? During the build, I saw some extra packages being downloaded and installed by maven. Are you referring to these? I also see some content in ~/.m2/repository. Are these the missing transitive dependencies?

Please excuse me for my ignorance with Java and Maven build process.

Regards,
rtnpro
Comment 26 Gwyn Ciesla 2014-12-10 10:02:06 EST
No owners specified.
Comment 27 Timothy St. Clair 2014-12-10 11:11:31 EST
@Ratnadeep - 

Yup.  

Perhaps we should open a new ticket given that mesos is already in f21 and out the door.

Note You need to log in before you can comment on or make changes to this bug.